package be.iminds.ilabt.jfed.experimenter_gui.editor.impl;

import be.iminds.ilabt.jfed.experimenter_gui.editor.ToolboxItem;
import be.iminds.ilabt.jfed.experimenter_gui.editor.views.EditableExperimentCanvas;
import be.iminds.ilabt.jfed.experimenter_gui.util.ImageUtil;
import be.iminds.ilabt.jfed.rspec.model.javafx_impl.FXRspecChannel;
import javafx.geometry.Point2D;
import javafx.scene.image.Image;

import static org.eclipse.jetty.io.SelectChannelEndPoint.LOG;

/**
 * User: twalcari
 * Date: 4/23/2015
 * Time: 16:32
 */
public class ChannelToolboxItem extends ToolboxItem {

    public static final int WEIGHT = -100;

    public ChannelToolboxItem() {
        super("channel",
                "Wireless Channel",
                new Image(ImageUtil.class.getResource("/images/wireless-channel.png").toExternalForm()),
                new Image(ImageUtil.class.getResource("/images/wireless-channel.png").toExternalForm(),32,32, true, true),
                WEIGHT);
    }

    @Override
    public void onAddedToCanvas(EditableExperimentCanvas canvas, Point2D location) {
        FXRspecChannel channel = canvas.getEditor().addChannel(location);
        boolean success = canvas.onConfigureChannelPressed(channel);

        if (success) {
            LOG.debug("Adding channel {} to canvas", channel.getComponentName());
            canvas.setStatus("Added channel " + channel.getComponentName() + " to the canvas");

        } else {
            LOG.warn("User did not properly configure channel. Removing it again!");

            canvas.getModel().deleteChannel(channel);
            canvas.setStatus("Channel was not properly configured!");
        }
    }
}
